

#include "main.h"





#include <SerialCommand.h>
SerialCommand sCmd;







#include <AccelStepper.h>
AccelStepper stepper(1, pin_step, pin_direction);



int timode=0;
int basesize=16;

int currentstepsize=8;
long stepspeed=2800;
long stepacceleration=stepspeed*16;
long currentbaseposition=0;


#define POWERTIMEOUT 10*1000

volatile unsigned int power_count;



void poweron()
{
 digitalWrite(pin_vmot,HIGH);
 power_count=0;
 OCR0A = 0x80;
 TIMSK0 |= _BV(OCIE0A);
}

void powerofflo()
{
 TIMSK0 &=~ _BV(OCIE0A);
 digitalWrite(pin_vmot,LOW);   
}

void poweroff()
{
 powerofflo();
}


ISR (TIMER0_COMPA_vect) 
{
 power_count++;
 if(power_count>POWERTIMEOUT)
 {
  powerofflo();
 }
}





void powerup_home()
{
 digitalWrite(pin_home_power,1);
}

void powerdown_home()
{
 digitalWrite(pin_home_power,0);
}

void powerup_stepper_logic()
{
 digitalWrite(pin_stepper_logic_power,1);  
}

void powerdown_stepper_logic()
{
 digitalWrite(pin_stepper_logic_power,0);    
}




// ss,<number of microsteps 1,2,4,8,16>


void setupstepsize(int msteps)
{
  if(msteps==1)
  {
   digitalWrite(pin_ms0,LOW);
   digitalWrite(pin_ms1,LOW);
   digitalWrite(pin_ms2,LOW);
  }
  else
  if(msteps==2)
  {
   digitalWrite(pin_ms0,HIGH);
   digitalWrite(pin_ms1,LOW);
   digitalWrite(pin_ms2,LOW);
  }
  else
  if(msteps==4)
  {
   digitalWrite(pin_ms0,LOW);
   digitalWrite(pin_ms1,HIGH);
   digitalWrite(pin_ms2,LOW);
  }
  else  
  if(msteps==8)
  {
   digitalWrite(pin_ms0,HIGH);
   digitalWrite(pin_ms1,HIGH);
   digitalWrite(pin_ms2,LOW);
  }
  else
  if(msteps==16)
  {
   if(timode)
   {
    digitalWrite(pin_ms0,LOW);
    digitalWrite(pin_ms1,LOW);
   }
   else
   {
    digitalWrite(pin_ms0,HIGH);
    digitalWrite(pin_ms1,HIGH);
   } 
   digitalWrite(pin_ms2,HIGH);
  }  
  else
  if(msteps==32)
  {
   digitalWrite(pin_ms0,HIGH);
   digitalWrite(pin_ms1,HIGH);
   digitalWrite(pin_ms2,HIGH);
  }  
}  







void flushstepsizechange()
{
 stepper.setMaxSpeed((stepspeed*currentstepsize)/basesize);
 stepper.setAcceleration((stepacceleration*currentstepsize)/basesize);  
}  


void setup_stepperlogic()
{
 powerup_stepper_logic();  
 flushstepsizechange();
 setupstepsize(currentstepsize);

}


void setdown_stepperlogic()
{
 setupstepsize(1);
 digitalWrite(pin_direction,LOW);
 digitalWrite(pin_step,LOW);
 powerdown_stepper_logic();
}




// mv <steps>

void cmdmove()
{
 char * arg; 
 long   steps;
 
 arg = sCmd.next();
 if(arg!=NULL)
 {
  steps=atol(arg);

  setup_stepperlogic();
  poweron();


  steps=(steps*currentstepsize)/basesize;

  stepper.move(steps);
  while(1)
  {
   if(stepper.distanceToGo()!=0)
   {
    stepper.run();
   }
   else
  {
   break; 
  }
 }

 poweroff();
 setdown_stepperlogic();
}
}






 
void cmdunrecognized(const char *command)
{
 pr("What?"); 
}  





#define THRESHOLD 200
#define MAXUP 4600
#define MAXDOWN (-800)

long homeposn;

int sensorhomelow(void)
{
 int val;
 long steps;
 int  result=0;

 powerup_home();
 
 val=analogRead(pin_home_signal);
// pr("home val %d",val);

 val=analogRead(pin_home_signal);
// pr("home val %d",val);

 val=analogRead(pin_home_signal);
// pr("home val %d",val);

 if(val>THRESHOLD)
 {
// gotta go up
  steps=MAXUP;     
 }
 else
 {
// gotta go down
  steps=MAXDOWN;
 }


 steps=(steps*currentstepsize)/basesize;
 stepper.move(steps);


 while(1)
 {
  if(stepper.distanceToGo()!=0)
  {
   stepper.run();
  }
  else
  {
// over
//pr("break");
   break; 
  }
  if(result==0)
  {
   val=analogRead(pin_home_signal);
   if(steps>0)
   {
    if(val<THRESHOLD)
    {
//     pr("hit high");
     stepper.stop(); 
     result=1;
     homeposn=stepper.currentPosition();
    }
   }
   else
   {
    if(val>THRESHOLD)
    {
//     pr("hit low");    
     stepper.stop(); 
     result=2;
     homeposn=stepper.currentPosition();
    }
   }
  }
 }

/* if(result)
 {
  pr("home posn %ld",posn);
  stepper.runToNewPosition(posn);
 }
*/ 

 powerdown_home();

 stepper.setCurrentPosition(stepper.currentPosition()-homeposn);

// Serial.println(result);
 
 return(result);
}

void sensorhome(void)
{
 int result;
  
 setup_stepperlogic();
 poweron();

 result=sensorhomelow();

 poweroff();
 setdown_stepperlogic();

 
}



long senseposn;

int senselow(void)
{ 
 long steps=(-MAXUP);     
 int result=0;
 int val;

 steps=(steps*currentstepsize)/basesize;
 stepper.move(steps);


 while(1)
 {
  if(stepper.distanceToGo()!=0)
  {
   stepper.run();
  }
  else
  {
   break; 
  }
  if(result==0)
  {
   val=digitalRead(pin_sensor);
   if(val==0)
   {
    stepper.stop(); 
    result=1;
    senseposn=stepper.currentPosition();
   }
  }
 }
 
 return(result);
}

void sense(void)
{
 int result; 
 setup_stepperlogic();
 poweron();
 result=senselow();
 poweroff();
 setdown_stepperlogic();
}

void read_distance()
{
 int result1; 
 int result2;

 setup_stepperlogic();
 poweron();
 delay(100);
 result1=senselow();
 result2=sensorhomelow();
 poweroff();
 setdown_stepperlogic();

 long posn=homeposn-senseposn;
 if(posn<0) posn=-posn;

 writedistance(posn);

 pr("result sense %d result home %d posn %ld",result1,result2,posn);
 long mm=(posn*50*2)/MAXUP;
 long mmposn=(mm*MAXUP)/(2*50);
 pr("mm %ld.%ld",mmposn,posn);
 posn=((posn-mmposn)*50*2*10)/MAXUP;
 pr("mm %ld.%ld",mm,posn);
}



void cmdtest()
{
 char * arg;
 int    pin=0;
 
 arg = sCmd.next();
 if(arg!=NULL)
 {
  pin=atoi(arg);

 } 

 read_distance();


/*
 unsigned long tx=millis();

 sense();
 sensorhome();


 pr("time %lu",millis()-tx);
*/ 
}  





void steppersetup() 
{                
  pinMode(pin_vmot,OUTPUT);
  poweroff();
  
  pinMode(pin_stepper_logic_power,OUTPUT);

  pinMode(pin_home_power,OUTPUT);
  
  pinMode(pin_led, OUTPUT);

  pinMode(pin_enable,OUTPUT);

  pinMode(pin_direction,OUTPUT);
  pinMode(pin_step,OUTPUT);
  
  pinMode(pin_ms0,OUTPUT);
  pinMode(pin_ms1,OUTPUT);
  pinMode(pin_ms2,OUTPUT);

  pinMode(pin_sensor,INPUT);

  pinMode(pin_vmot,OUTPUT);
}

void cmdsetup()
{
  sCmd.addCommand("mv",cmdmove); 
  sCmd.addCommand("ts",cmdtest);
  sCmd.addCommand("hm",sensorhome);
  sCmd.addCommand("se",sense);
    
 sCmd.setDefaultHandler(cmdunrecognized);  
}



void cmdloop()
{
 if(Serial.available()>0) 
 {
  sCmd.readSerial();
 }
}
